diff --git a/src/common/SurgePatch.cpp b/src/common/SurgePatch.cpp
index 33a5c9eb4..284c7383b 100644
--- a/src/common/SurgePatch.cpp
+++ b/src/common/SurgePatch.cpp
@@ -35,25 +35,6 @@ const int gui_modsec_x = 6, gui_modsec_y = 398 + gui_topbar;
 
 const int gui_mid_topbar_y = 17;
 
-// XML storage fileformat revision
-// 0 -> 1 new EG attack shapes (0>1, 1>2, 2>2)
-// 1 -> 2 new LFO EG stages (if (decay == max) sustain = max else sustain = min
-// 2 -> 3 filter subtypes added comb should default to 1 and moog to 3
-// 3 -> 4 comb+/- combined into 1 filtertype (subtype 0,0->0 0,1->1 1,0->2 1,1->3 )
-// 4 -> 5 stereo filterconf now have seperate pan controls
-// 5 -> 6 new filter sound in v1.2 (same parameters, but different sound & changed resonance
-// response).
-// 6 -> 7 custom controller state now stored (in seq. recall)
-// 7 -> 8 larger resonance
-// range (old filters are set to subtype 1), pan2 -> width
-// 8 -> 9 now 8 controls (offset ids larger
-// than ctrl7 by +1), custom controllers have names (guess for pre-rev9 patches)
-// 9 -> 10 added character parameter
-// 10 -> 11 (1.6.2 release) added DAW Extra State
-// 11 -> 12 (1.6.3 release) added new parameters to the Distortion effect
-// 12 -> 13 (1.7.0 release) deactivation; sine LP/HP
-const int ff_revision = 13;
-
 SurgePatch::SurgePatch(SurgeStorage* storage)
 {
    this->storage = storage;
diff --git a/src/common/SurgeStorage.cpp b/src/common/SurgeStorage.cpp
index 66f4e5afc..5ecef2002 100644
--- a/src/common/SurgeStorage.cpp
+++ b/src/common/SurgeStorage.cpp
@@ -349,6 +349,24 @@ SurgeStorage::SurgeStorage(std::string suppliedDataPath) : otherscene_clients(0)
    {
        userDataPath = userSpecifiedDataPath;
    }
+
+   userFXPath = userDataPath +
+#if WINDOWS
+      "\\"
+#else
+      "/"
+#endif
+      + "FXSettings";
+
+   
+   userMidiMappingsPath = userDataPath +
+#if WINDOWS
+      "\\"
+#else
+      "/"
+#endif
+      + "MIDIMappings";
+   
    
 #if LINUX
    if (!snapshotloader.Parse((const char*)&configurationXmlStart, 0,
diff --git a/src/common/SurgeStorage.h b/src/common/SurgeStorage.h
index 190ac23d5..90dcace9a 100644
--- a/src/common/SurgeStorage.h
+++ b/src/common/SurgeStorage.h
@@ -48,6 +48,25 @@ const int FIRoffset = FIRipol_N >> 1;
 const int FIRipolI16_N = 8;
 const int FIRoffsetI16 = FIRipolI16_N >> 1;
 
+// XML storage fileformat revision
+// 0 -> 1 new EG attack shapes (0>1, 1>2, 2>2)
+// 1 -> 2 new LFO EG stages (if (decay == max) sustain = max else sustain = min
+// 2 -> 3 filter subtypes added comb should default to 1 and moog to 3
+// 3 -> 4 comb+/- combined into 1 filtertype (subtype 0,0->0 0,1->1 1,0->2 1,1->3 )
+// 4 -> 5 stereo filterconf now have seperate pan controls
+// 5 -> 6 new filter sound in v1.2 (same parameters, but different sound & changed resonance
+// response).
+// 6 -> 7 custom controller state now stored (in seq. recall)
+// 7 -> 8 larger resonance
+// range (old filters are set to subtype 1), pan2 -> width
+// 8 -> 9 now 8 controls (offset ids larger
+// than ctrl7 by +1), custom controllers have names (guess for pre-rev9 patches)
+// 9 -> 10 added character parameter
+// 10 -> 11 (1.6.2 release) added DAW Extra State
+// 11 -> 12 (1.6.3 release) added new parameters to the Distortion effect
+// 12 -> 13 (1.7.0 release) deactivation; sine LP/HP
+const int ff_revision = 13;
+
 extern float sinctable alignas(16)[(FIRipol_M + 1) * FIRipol_N * 2];
 extern float sinctable1X alignas(16)[(FIRipol_M + 1) * FIRipol_N];
 extern short sinctableI16 alignas(16)[(FIRipol_M + 1) * FIRipolI16_N];
@@ -593,6 +612,8 @@ class alignas(16) SurgeStorage
    std::string datapath;
    std::string userDataPath;
    std::string userDefaultFilePath;
+   std::string userFXPath;
+   std::string userMidiMappingsPath;
 
    // float table_sin[512],table_sin_offset[512];
    Surge::CriticalSection CS_WaveTableData, CS_ModRouting;
diff --git a/src/common/gui/CSnapshotMenu.cpp b/src/common/gui/CSnapshotMenu.cpp
index 4c19ff4a3..e02c21c55 100644
--- a/src/common/gui/CSnapshotMenu.cpp
+++ b/src/common/gui/CSnapshotMenu.cpp
@@ -57,7 +57,11 @@ void CSnapshotMenu::populate()
       while (type)
       {
          if( type->Value() && strcmp( type->Value(), "type" ) == 0  )
-            populateSubmenuFromTypeElement(type, this, main, sub, max_sub, idx);
+         {
+            auto sm = populateSubmenuFromTypeElement(type, this, main, sub, max_sub, idx);
+            if( sm )
+               addToTopLevelTypeMenu(type, sm);
+         }
          else if( type->Value() && strcmp( type->Value(), "separator" ) == 0 )
             addSeparator();
          type = type->NextSiblingElement();
@@ -125,7 +129,7 @@ bool CSnapshotMenu::loadSnapshotByIndex( int idx )
    return false;
 }
 
-void CSnapshotMenu::populateSubmenuFromTypeElement(TiXmlElement *type, VSTGUI::COptionMenu *parent, int &main, int &sub, const long &max_sub, int &idx)
+VSTGUI::COptionMenu* CSnapshotMenu::populateSubmenuFromTypeElement(TiXmlElement *type, VSTGUI::COptionMenu *parent, int &main, int &sub, const long &max_sub, int &idx)
 {
     /*
     ** Begin by grabbing all the snapshot elements
@@ -209,48 +213,10 @@ void CSnapshotMenu::populateSubmenuFromTypeElement(TiXmlElement *type, VSTGUI::C
     }
 
     subMenu->forget();
-
-    /*if (canSave())
-      {
-      addEntry("-");
-      addEntry("Store Current");
-      }*/
-    /*
-      int32_t sel_id = contextMenu->get Last Result();
-      this is commented so put in spaces so my grep to kill all these doesn't flag it PW
-      int32_t sub_id, main_id;
-      COptionMenu *b = contextMenu->getLastItemMenu(sub_id);
-      if (b) main_id = b->getTag();
-
-      if ((sel_id >= 0) && (sel_id < contextMenu->getNbEntries()))
-      {
-      if (sel_id < main)
-      {
-      int type_id = 0; xpp[sel_id&(max_main - 1)]->Attribute("i", &type_id);		//
-      get "i" value from xmldata load_snapshot(type_id, 0);
-      }
-      else
-      {
-      char name[NAMECHARS];
-      sprintf(name, "default");
-
-      spawn_miniedit_text(name, NAMECHARS);
-      save_snapshot(sect, name);
-      storage->save_snapshots();
-      do_nothing = true;
-      }
-      }
-      else if (b && within_range(0, main_id, max_main) && within_range(0, sub_id, max_sub))
-      {
-      if (xp[main_id][sub_id])
-      {
-      int type_id = 0; xpp[main_id&(max_main - 1)]->Attribute("i", &type_id);		//
-      get "i" value from xmldata
-
-      load_snapshot(type_id, xp[main_id][sub_id]);
-      }
-      }
-      else do_nothing = true;*/
+    if( sub )
+       return subMenu; // OK to return forgoten since it has lifetime of parent
+    else
+       return nullptr;
 }
 
 // COscMenu
@@ -477,22 +443,14 @@ void CFxMenu::saveSnapshot(TiXmlElement* e, const char* name)
 }
 
 bool CFxMenu::scanForUserPresets = true;
-std::vector<CFxMenu::UserPreset> CFxMenu::userPresets;
+std::unordered_map<int,std::vector<CFxMenu::UserPreset>> CFxMenu::userPresets;
 
 void CFxMenu::rescanUserPresets()
 {
    userPresets.clear();
    scanForUserPresets = false;
 
-   std::ostringstream oss;
-   oss << storage->userDataPath
-#if WINDOWS
-       << "\\"
-#else
-       << "/"
-#endif      
-       << "FXSettings";
-   auto ud = oss.str();
+   auto ud = storage->userFXPath;
 
    if( fs::is_directory( fs::path( ud ) ) ) {
       for( auto &d : fs::directory_iterator( fs::path( ud ) ) )
@@ -537,33 +495,33 @@ void CFxMenu::rescanUserPresets()
                   preset.er[i] = fl;
                }
             }
-            
-            userPresets.push_back(preset);
+            if( userPresets.find(preset.type) == userPresets.end() )
+               userPresets[preset.type] = std::vector<UserPreset>();
+            userPresets[preset.type].push_back(preset);
          }
       badPreset:
          ;
       }
    }
 
-   std::sort( userPresets.begin(), userPresets.end(),
-              [](UserPreset a, UserPreset b)
-                 {
-                    if( a.type == b.type )
-                    {
-                       return _stricmp( a.name.c_str(), b.name.c_str() ) < 0;
-                    }
-                    else
+   for( auto &a : userPresets )
+      std::sort( a.second.begin(), a.second.end(),
+                 [](UserPreset a, UserPreset b)
                     {
-                       return a.type < b.type;
+                       if( a.type == b.type )
+                       {
+                          return _stricmp( a.name.c_str(), b.name.c_str() ) < 0;
+                       }
+                       else
+                       {
+                          return a.type < b.type;
+                       }
                     }
-                 }
-      );
+         );
 }
 
 void CFxMenu::populate()
 {
-    CSnapshotMenu::populate();
-
     /*
     ** Are there user preets
     */
@@ -572,45 +530,8 @@ void CFxMenu::populate()
        rescanUserPresets();
     }
 
-    if( userPresets.size() > 0 )
-    {
-       this->addSeparator();
-       auto userPMenu = new COptionMenu(getViewSize(), 0, 0, 0, 0, kNoDrawStyle );
-       COptionMenu *fxMenu = nullptr;
-       int lastType = -1;
-       for( auto ps : userPresets )
-       {
-          if( ps.type != lastType )
-          {
-             if( fxMenu ) {
-                userPMenu->addEntry( fxMenu, fxtype_abberations[lastType] );
-                fxMenu->forget();
-             }
-             lastType = ps.type;
-             fxMenu = new COptionMenu(getViewSize(), 0, 0, 0, 0, kNoDrawStyle );
-          }
-
-          std::string fxName = ps.name;
-
-          #if WINDOWS
-             Surge::Storage::findReplaceSubstring(fxName, std::string("&"), std::string("&&"));
-          #endif
-
-          auto i = new CCommandMenuItem(CCommandMenuItem::Desc(fxName.c_str()));
-          i->setActions([this,ps](CCommandMenuItem *item)
-                           {
-                              this->loadUserPreset(ps);
-                           } );
-          fxMenu->addEntry(i);
-       }
-       if( fxMenu ) {
-          userPMenu->addEntry( fxMenu, fxtype_abberations[lastType]  );
-          fxMenu->forget();
-       }
-       addEntry( userPMenu, "User Presets" );
-       userPMenu->forget();
-    }
-    
+    CSnapshotMenu::populate();
+
     /*
     ** Add copy/paste/save
     */
@@ -761,15 +682,7 @@ void CFxMenu::saveFX()
       return;
    }
    
-   std::ostringstream poss;
-   poss << storage->userDataPath
-#if WINDOWS
-        << "\\"
-#else
-        << "/"
-#endif
-        << "FXSettings";
-   std::string pn = poss.str();
+   std::string pn = storage->userFXPath;
    fs::create_directories( pn );
 
    std::ostringstream oss;
@@ -789,7 +702,7 @@ void CFxMenu::saveFX()
       return;
    }
 
-   pfile << "<single-fx>\n";
+   pfile << "<single-fx streaming_versio=\"" << ff_revision << "\">\n";
 
    // take care of 5 special XML characters
    std::string fxNameSub(fxName);
@@ -804,23 +717,26 @@ void CFxMenu::saveFX()
    pfile << "     type=\"" <<  fx->type.val.i << "\"\n";
    for( int i=0; i<n_fx_params; ++i )
    {
-      switch( fx->p[i].valtype )
+      if( fx->p[i].ctrltype != ct_none )
       {
-      case vt_float:
-         pfile << "     p" << i << "=\"" << fx->p[i].val.f << "\"\n";
-         break;
-      case vt_int:
-         pfile << "     p" << i << "=\"" << fx->p[i].val.i << "\"\n";
-         break;
-      }
-
-      if( fx->p[i].can_temposync() && fx->p[i].temposync )
-      {
-         pfile << "     p" << i << "_temposync=\"1\"\n";
-      }
-      if( fx->p[i].can_extend_range() && fx->p[i].extend_range )
-      {
-         pfile << "     p" << i << "_extend_range=\"1\"\n";
+         switch( fx->p[i].valtype )
+         {
+         case vt_float:
+            pfile << "     p" << i << "=\"" << fx->p[i].val.f << "\"\n";
+            break;
+         case vt_int:
+            pfile << "     p" << i << "=\"" << fx->p[i].val.i << "\"\n";
+            break;
+         }
+         
+         if( fx->p[i].can_temposync() && fx->p[i].temposync )
+         {
+            pfile << "     p" << i << "_temposync=\"1\"\n";
+         }
+         if( fx->p[i].can_extend_range() && fx->p[i].extend_range )
+         {
+            pfile << "     p" << i << "_extend_range=\"1\"\n";
+         }
       }
    }
 
@@ -869,3 +785,33 @@ void CFxMenu::loadUserPreset( const UserPreset &p )
       listenerNotForParent->valueChanged( this );
 
 }
+
+void CFxMenu::addToTopLevelTypeMenu(TiXmlElement *type, VSTGUI::COptionMenu *subMenu)
+{
+   if( ! type || ! subMenu ) return;
+   int type_id = 0;
+   type->Attribute("i", &type_id);
+
+   if( userPresets.find(type_id) == userPresets.end() || userPresets[type_id].size() == 0 )
+      return;
+
+   subMenu->addSeparator();
+   auto factory_add = subMenu->addEntry("USER PRESETS");
+   factory_add->setEnabled(0);
+
+   for( auto &ps : userPresets[type_id] )
+   {
+      auto fxName = ps.name;
+      
+#if WINDOWS
+      Surge::Storage::findReplaceSubstring(fxName, std::string("&"), std::string("&&"));
+#endif
+
+      auto i = new CCommandMenuItem(CCommandMenuItem::Desc(fxName.c_str()));
+      i->setActions([this,ps](CCommandMenuItem *item)
+                       {
+                          this->loadUserPreset(ps);
+                       } );
+      subMenu->addEntry(i);
+   }
+}
diff --git a/src/common/gui/CSnapshotMenu.h b/src/common/gui/CSnapshotMenu.h
index a19f410d0..11eda265b 100644
--- a/src/common/gui/CSnapshotMenu.h
+++ b/src/common/gui/CSnapshotMenu.h
@@ -7,6 +7,8 @@
 #include "PopupEditorSpawner.h"
 #include "SurgeBitmaps.h"
 #include "SkinSupport.h"
+#include <unordered_map>
+#include <vector>
 
 class CSnapshotMenu : public VSTGUI::COptionMenu, public Surge::UI::SkinConsumingComponnt
 {
@@ -34,7 +36,8 @@ class CSnapshotMenu : public VSTGUI::COptionMenu, public Surge::UI::SkinConsumin
    int selectedIdx = -1;
    std::string selectedName = "";
 protected:
-   void populateSubmenuFromTypeElement(TiXmlElement *typeElement, VSTGUI::COptionMenu *parent, int &main, int &sub, const long &max_sub, int &idx);
+   VSTGUI::COptionMenu *populateSubmenuFromTypeElement(TiXmlElement *typeElement, VSTGUI::COptionMenu *parent, int &main, int &sub, const long &max_sub, int &idx);
+   virtual void addToTopLevelTypeMenu(TiXmlElement *typeElement, VSTGUI::COptionMenu *subMenu) { }
    SurgeStorage* storage = nullptr;
    char mtype[16] = {0};
 
@@ -82,6 +85,7 @@ class CFxMenu : public CSnapshotMenu
    virtual void populate() override;
    
 protected:
+   virtual void addToTopLevelTypeMenu(TiXmlElement *typeElement, VSTGUI::COptionMenu *subMenu) override;
    FxStorage *fx = nullptr, *fxbuffer = nullptr;
    static std::vector<float> fxCopyPaste; // OK this is a crap data structure for now. See the code.
    int slot = 0;
@@ -106,7 +110,7 @@ class CFxMenu : public CSnapshotMenu
       float p[n_fx_params];
       bool ts[n_fx_params], er[n_fx_params];
    };
-   static std::vector<UserPreset> userPresets;
+   static std::unordered_map<int,std::vector<UserPreset>> userPresets; // from type to presets
    static bool scanForUserPresets;
    
    void rescanUserPresets();
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index d98798e3e..69ab07921 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -1077,6 +1077,7 @@ void SurgeGUIEditor::openOrRecreateEditor()
    fxPresetLabel->setTransparency(true);
    fxPresetLabel->setFont( displayFont );
    fxPresetLabel->setHoriAlign( kRightText );
+   fxPresetLabel->setTextTruncateMode( CTextLabel::TextTruncateMode::kTruncateTail );
    frame->addView(fxPresetLabel);
 
    CHSwitch2* b_store = new CHSwitch2(CRect(547 - 37, 41, 547, 41 + 12), this, tag_store, 1, 12, 1,
